/* Algoritmische Anwendungen Praktikum
   Projekt:Data Enscryption Standard (DES)
   @author: Adil Sbiyou, Tawfik El Moussaid
**/
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import java.util.EventObject;

public class DataEncryptionStandard extends JFrame
                                    implements ActionListener, Runnable, DocumentListener, ItemListener
{
  // Anfang Variablen
  String t="Algorithmische Anwendungen Praktikum.Data Encryption Standard von Gruppe C Gruen:"+
           "Adil Sbiyou,Tawfik El Moussaid";
  String info="Ablauf der Verschlsselung mit DES.Der Algorithmus wird 16 Mal durchlaufen,"+
              "bevor die Ausgangspermutation durchgefhrt wird";

  private JLabel schluessel = new JLabel("Schluessel");
  private JLabel eingabe = new JLabel("Eingabe");
  private JLabel ausgabe = new JLabel("Ausgabe");
  private JLabel geschwindigkeit = new JLabel("Verzoegerung");
  private JLabel option = new JLabel("Modus");
  private JLabel d = new JLabel(t);

  private JTextField key = new JTextField();
  private JScrollPane jScrollPanejTextArea = new JScrollPane();
  private JScrollPane jScrollPanejTextArea2 = new JScrollPane();
  private JTextArea text= new JTextArea("", 10, 80);
  private JTextArea verText = new JTextArea("", 10, 80);
  private JComboBox cmode = new JComboBox();
  private JComboBox geschw = new JComboBox();
  private JButton bcrypte = new JButton();
  private JButton bnext = new JButton();

  Graphics g1;

  public DataEncryptionStandard()
  {
        super("Algorithmische Anwendungen:Data Encryption Standard(DES)");
        setVisible(true);
        Container cp = getContentPane();
        getContentPane().setBackground(Color.white);

        addWindowListener(new WindowAdapter()
        {
          public void windowClosing(WindowEvent e)
          {
           setVisible(false);
           dispose();
           System.exit(0);
          }
        }
        );

        police_aus = new Font("DialogInput", 1, 12);
        police_in = new Font("Serif", 0, 12);
        bild = createImage(750, 500);
        MediaTracker mediatracker = new MediaTracker(this);
        image = getToolkit().getImage("algo.gif");
        if(image != null)
        {
            mediatracker.addImage(image, 0);
            try
            {
                mediatracker.waitForID(0);
            }
            catch(InterruptedException _ex)
            {
                image = null;
            }
        }

        setSize(800, 700);

        cp.setLayout(null);

        // Anfang Komponenten
        schluessel.setBounds(20,0,100,30);
        schluessel.setForeground(Color.gray);
        key.setBounds(150, 10, 530, 20);
        key.setText("Algo");
        key.setBorder(BorderFactory.createLineBorder(Color.gray));

        cp.add(schluessel);
        cp.add(key);

        key.getDocument().addDocumentListener(this);


        String s = "Der Data Encryption Standard (ausgesprochen: dee-ee-ess oder dez) ist ein weit verbreiteter\n symmetrischer Verschlsselungsalgorithmus.";
        s = s + "Der Algorithmus wurde als offizieller Standard\n fr die USA im Jahr 1976 besttigt.";
        s = s + "Seine Entstehungsgeschichte hat wegen der Beteiligung\n der NSA am Design des Algorithmus immer wieder Anlass zu Spekulationen ber seine\n Sicherheit gegeben.";
        s = s + "Heute wird DES aufgrund der Schlssellnge von nur 56Bit fr viele\n Anwendungen als nicht ausreichend sicher erachtet.";
        s = s + "In verschiedenen Dokumentationen wird\n DES auch als DEA (Data Encryption Algorithm) bezeichnet.";

        jScrollPanejTextArea2.setBounds(150, 40, 530, 180);
        jScrollPanejTextArea2.setViewportView(text);
        cp.add(jScrollPanejTextArea2);
        text.setText(s);


        eingabe.setBounds(20,25,100,30);
        eingabe.setForeground(Color.gray);
        cp.add(eingabe);
        
        verText.setText("");
        jScrollPanejTextArea.setBounds(150, 240, 530, 200);
        verText.setEditable(false);
        jScrollPanejTextArea.setViewportView(verText);

        ausgabe.setBounds(20,225,100,30);
        ausgabe.setForeground(Color.gray);
        cp.add(ausgabe);
        cp.add(jScrollPanejTextArea);


        bcrypte.setBounds(150, 480, 150, 20);
        bcrypte.setText("Verschluesseln");
        cp.add(bcrypte);

        bcrypte.addActionListener(this);

        //Schrittweise ausfuehren
        bnext.setBounds(320, 480, 80, 20);
        bnext.setText(">");
        cp.add(bnext);

        bnext.addActionListener(this);

        option.setFont (new Font("MS Sans Serif", Font.PLAIN, 12));
        geschwindigkeit.setFont (new Font("MS Sans Serif", Font.PLAIN, 12));

        //geschwindigkeit
        geschwindigkeit.setBounds(420,455,180,30);

        geschw.setBounds(420, 480, 100, 20);
        geschw.addItemListener(this);
        geschw.addItem("Sehr langsam");
        geschw.addItem("Langsam");
        geschw.addItem("Normal");
        geschw.addItem("Schnell");
        geschw.addItem("Sehr schnell");
        geschw.setSelectedItem("Normal");
        cp.add(geschwindigkeit);
        cp.add(geschw);

        //option
        option.setBounds(540,455,100,30);
        cmode.setBounds(540, 480, 140, 20);
        cmode.addItemListener(this);
        cmode.addItem("Verschluesseln");
        cmode.addItem("Entschluesseln");
        cmode.setSelectedItem("Verschluesseln");

        cp.add(option);
        cp.add(cmode);

        d.setFont (new Font("MS Sans Serif", Font.PLAIN, 12));
        d.setBounds(65,640,660,20);
        add(d);

        ttext = "";
        btext = "";
        bpi = "";
        li = "";
        ri = "";
        li1 = "";
        ri1 = "";
        bep = "";
        tverschlusseln = "";
        schlussel48 = "";
        tkey = "";
        bschlussel = "";
        G = "";
        D = "";
        xor1 = "";
        RTS = "";
        PP = "";
        ausgang = "";
        PF = "";
        keys = new String[17];
        speed = 700;
        laeuft = false;
        bverschlusseln = true;
        pos = 0;
        runde = 0;
        lausgang = 0;
        
        setVisible(true);
    }


    public static void main(String[] args)
    {
      new DataEncryptionStandard();
    }
    // Anfang Ereignisprozeduren
    public void actionPerformed(ActionEvent actionevent)
    {
        if(actionevent.getSource() == bcrypte)
            if(laeuft)
            ende();
            else
            {
                schlussel_vorbereiten();
                key.setText(tkey);
                ttext = text.getText();
                tverschlusseln = "";
                verText.setText("");
                pos = 0;
                runde = -1;
                lausgang = 0;
                prozess = new Thread(this);
                laeuft = true;
                bcrypte.setText("Stop");
                anfang();
                prozess.start();
            }
            if(actionevent.getSource() == bnext)
            if(laeuft)
            {
                prozess = null;
                schrit();
                repaint();
            }
            else
            {
                schlussel_vorbereiten();
                ttext = text.getText();
                pos = 0;
                runde = -1;
                lausgang = 0;
                laeuft = true;
                anfang();
                bcrypte.setText("Modus Wechseln");
            }
    }

    public void anfang()
    {
        key.setEditable(false);
        jScrollPanejTextArea2.setVisible(false);
        text.setEditable(false);
        cmode.setEnabled(false);
        d.setVisible(false);
        key.setVisible(false);
        text.setVisible(false);
        jScrollPanejTextArea.setBounds(142,480,530,120);
        ausgabe.setBounds(20,465,100,30);
        bcrypte.setBounds(142,630,150,20);
        bnext.setBounds(312,630,80,20);
        geschw.setBounds(412,630,100,20);
        cmode.setBounds(532,630,140,20);
        geschwindigkeit.setBounds(412,605,100,30);
        option.setBounds(532,605,100,30);
        repaint();
    }

    public void schrit()
    {
        runde++;
        if(runde > 17)
            runde = 0;
        if(runde == 0)
        {
            ausgang = "";
            int i = pos;
            if(pos < ttext.length())
            {
                String s = "";
                char c = ' ';
                while(s.length() < 8)
                {
                    char c1 = ' ';
                    boolean flag = false;
                    if(pos < ttext.length())
                        c1 = ttext.charAt(pos);
                    else
                        c1 = ' ';
                    if(pos + 6 < ttext.length() && c1 == '\\' && (ttext.charAt(pos + 1) == 'u' || ttext.charAt(pos + 1) == 'U'))
                    {
                        String s4 = ttext.substring(pos + 2, pos + 6);
                        try
                        {
                            int j3 = Integer.valueOf(s4, 16).intValue();
                            flag = true;
                            c = (char)j3;
                        }
                        catch(Exception _ex)
                        {
                            flag = false;
                        }
                        pos += 6;
                    }
                    if(!flag && (bverschlusseln || c1 >= '\024'))
                    {
                        c = c1;
                        flag = true;
                        pos++;
                    }
                    if(flag)
                        s = s + c;
                    else
                        pos++;
                }
                if(pos > ttext.length())
                    pos = ttext.length();
                text.select(i, pos);
                text.repaint();
                btext = "";
                for(int j2 = 0; j2 < 8; j2++)
                {
                    char c3 = s.charAt(j2);
                    String s3;
                    for(s3 = Integer.toBinaryString(c3); s3.length() < 8; s3 = "0" + s3);
                    btext = btext + s3;
                }

                bpi = "";
                for(int l2 = 0; l2 < 64; l2++)
                    bpi = bpi + btext.charAt(EinP[l2] - 1);

                keys[0] = "";
                for(int k3 = 0; k3 < schluesselP.length; k3++)
                    keys[0] = keys[0] + bschlussel.charAt(schluesselP[k3] - 1);

                G = "";
                li = bpi.substring(32, 64);
                D = "";
                ri = bpi.substring(0, 32);
            } else
            {
                ende();
            }
        }
        if(runde > 0 && runde < 17)
        {
            li1 = new String(ri);
            ri1 = new String(li);
            G = keys[runde - 1].substring(0, 28);
            D = keys[runde - 1].substring(28, 56);
            if(bverschlusseln)
            {
                for(int j = 0; j < Decal[runde]; j++)
                {
                    G = G.substring(1, 28) + G.charAt(0);
                    D = D.substring(1, 28) + D.charAt(0);
                }

            } else
            {
                for(int k = 0; k < Decalb[runde]; k++)
                {
                    G = G.charAt(27) + G.substring(0, 27);
                    D = D.charAt(27) + D.substring(0, 27);
                }

            }
            keys[runde] = G + D;
            schlussel48 = "";
            for(int l = 0; l < 48; l++)
                schlussel48 = schlussel48 + keys[runde].charAt(KP[l] - 1);

            bep = "";
            for(int j1 = 0; j1 < 48; j1++)
                bep = bep + ri1.charAt(EP[j1] - 1);

            xor1 = "";
            for(int l1 = 0; l1 < 48; l1++)
                if(bep.charAt(l1) == schlussel48.charAt(l1))
                    xor1 = xor1 + '0';
                else
                    xor1 = xor1 + '1';

            RTS = "";
            for(int k2 = 0; k2 < 8; k2++)
            {
                String s1 = xor1.substring(k2 * 6, k2 * 6 + 6);
                int l3 = Integer.parseInt("" + s1.charAt(0) + s1.charAt(5), 2);
                int j4 = Integer.parseInt("" + s1.charAt(1) + s1.charAt(2) + s1.charAt(3) + s1.charAt(4), 2);
                RTS = RTS + Table_S[k2][l3][j4];
            }

            PP = "";
            for(int i3 = 0; i3 < 32; i3++)
                PP = PP + RTS.charAt(PBP[i3] - 1);

            ri = "";
            for(int i4 = 0; i4 < 32; i4++)
                if(li1.charAt(i4) == PP.charAt(i4))
                    ri = ri + '0';
                else
                    ri = ri + '1';

            li = new String(ri);
            ri = new String(ri1);
        }
        if(runde == 17)
        {
            ausgang = li + ri;
            PF = "";
            for(int i1 = 0; i1 < 64; i1++)
                PF = PF + ausgang.charAt(SchlussP[i1] - 1);

            for(int k1 = 0; k1 < 8; k1++)
            {
                int i2 = Integer.parseInt(PF.substring(k1 * 8, k1 * 8 + 8), 2);
                char c2 = (char)i2;
                if((i2 < 32 || i2 > 254) && bverschlusseln)
                {
                    String s2;
                    for(s2 = Integer.toHexString(i2).toUpperCase(); s2.length() < 4; s2 = "0" + s2);
                    tverschlusseln = tverschlusseln + "\\u" + s2;
                } else
                {
                    tverschlusseln = tverschlusseln + c2;
                }
            }

            if(bverschlusseln)
            {
                lausgang++;
                if(lausgang > 5)
                {
                    lausgang = 0;
                    tverschlusseln = tverschlusseln + "\n";
                }
            }
            verText.setText(tverschlusseln);
        }
        repaint();
    }

    public void ende()
    {
        jScrollPanejTextArea.setBounds(150, 240, 530, 200);
         jScrollPanejTextArea2.setBounds(150, 40, 530, 180);
        prozess = null;
        key.setEditable(true);
        text.setEditable(true);
        if(bverschlusseln)
            bcrypte.setText("Verschluesseln");
        else
            bcrypte.setText("Entschluesseln");
        laeuft = false;
        cmode.setEnabled(true);
        repaint();
    }

    public void itemStateChanged(ItemEvent itemevent)
    {

            JComboBox s = (JComboBox)itemevent.getSource();

            if(s.getSelectedItem().equals("Sehr langsam"))
                speed = 3000;
            else
            if(s.getSelectedItem().equals("Langsam"))
                speed = 1500;
            else
            if(s.getSelectedItem().equals("Normal"))
                speed = 700;
            else
            if(s.getSelectedItem().equals("Schnell"))
                speed = 70;
            else
            if(s.getSelectedItem().equals("Sehr schnell"))
                speed = 10;
            else
            if(s.getSelectedItem().equals("Verschluesseln"))
            {
                bcrypte.setText("Verschluesseln");
                bverschlusseln = true;
            } else
            if(s.getSelectedItem().equals("Entschluesseln"))
            {
                bcrypte.setText("Entschluesseln");
                bverschlusseln = false;
            }
        }

    public void paint(Graphics g)
    {
        update(g);
    }

    public void schlussel_vorbereiten()
    {
        tkey = key.getText()+"        ";
        tkey = tkey.substring(0, 8);
        bschlussel = "";
        for(int i = 0; i < 8; i++)
        {
            char c = tkey.charAt(i);
            String s;
            for(s = Integer.toBinaryString(c); s.length() < 8; s = "0" + s);
            bschlussel = bschlussel + s;
        }

    }

    public void run()
    {
        for(Thread thread = Thread.currentThread(); prozess == thread;)
        {
            try
            {
                Thread.sleep(speed);
            }
            catch(InterruptedException _ex) { }
            schrit();
            repaint();
        }

    }

    public void start()
    {
    }

    public void stop()
    {
        ende();
        prozess = null;
    }

    public void changedUpdate(DocumentEvent e)
    {
        if(e.getDocument() == key)
        {
            schlussel_vorbereiten();
            repaint();
        }
    }
    public void removeUpdate(DocumentEvent e)
    {
    }
    public void insertUpdate(DocumentEvent e)
    {
    }
    public void update(Graphics g)
    {
        int j = 0;
        int l = 0;
        int i1 = 0;

        g1 = bild.getGraphics();
        g1.setFont(police_in);
        if(image != null)
        {
            int i = image.getHeight(this);
            int k = image.getWidth(this);
            if(i > 0 && k > 0)
            {
                int j1 = 0;
                for(int l1 = 0; l1 < 500; l1 += i)
                {
                    while(j1 < 750)
                    {
                        g1.drawImage(image, j1, l1, k,i , this);
                        j1 += k;
                    }
                    j1 = 0;
                }

            }
        }
        if(laeuft)
        {
          d.setVisible(false);
          jScrollPanejTextArea2.setVisible(false);
          text.setVisible(false);
          key.setVisible(false);
          jScrollPanejTextArea.setBounds(142,480,530,120);
          ausgabe.setBounds(20,465,100,30);
          bcrypte.setBounds(142,630,150,20);
          bnext.setBounds(312,630,80,20);
          geschw.setBounds(412,630,100,20);
          cmode.setBounds(532,630,140,20);
          geschwindigkeit.setBounds(412,605,100,30);
          option.setBounds(532,605,100,30);

           g1.setFont (new Font("MS Sans Serif", Font.BOLD, 13));
           g1.setColor(Color.red);
           if(key.getText().length()<8)
           g1.drawString(key.getText(),25, 110);
           else
           g1.drawString(key.getText().substring(0,8),25, 110);

           g1.setFont (new Font("Arial", Font.PLAIN, 13));
           g1.setColor(Color.black);
           g1.drawString("Ablauf der Verschlsselung mit DES.Der Algorithmus wird 16 Mal durchlaufen,bevor die Ausgangspermutation durchgefhrt wird.",15,50);
           g1.setFont(new Font("MS Sans Serif", Font.PLAIN, 13));
           g1.drawString(" in binaer :", 85, 110);
        }
        else
            {
            jScrollPanejTextArea2.setVisible(true);
            d.setVisible(true);
            text.setVisible(true);
            key.setVisible(true);
            ausgabe.setBounds(20,225,100,30);
            bcrypte.setBounds(150, 480, 150, 20);
            bnext.setBounds(320, 480, 80, 20);
            geschwindigkeit.setBounds(420,455,180,30);
            geschw.setBounds(420, 480, 100, 20);
            option.setBounds(540,455,100,30);
            cmode.setBounds(540, 480, 140, 20);
            }
        if(!laeuft)
           {

           setBackground(Color.white);
           g.drawImage(bild, 0, 0, 800, 700, this);
           return;
        }
        g1.setFont(police_aus);
        j = g1.getFontMetrics().stringWidth(bschlussel.substring(0, 32));
        l = g1.getFontMetrics().stringWidth(bschlussel.substring(0, 28));
        i1 = g1.getFontMetrics().stringWidth(bschlussel.substring(0, 24));
        g1.setColor(Color.white);
        //rec1
        g1.fillRect(145, 155, j + 10, 35);
        if(runde == 0)
        //rec2
        g1.fillRect(145, 195, j + 10, 35);
        if(runde < 17)
        {
        //kleine rect links in rot bereich
        g1.fillRect(135 - j / 2, 240, j + 10, 15);
        g1.fillRect(155 + j / 2, 240, j + 10, 15);
        }
        if(runde > 0)
        {
        //rotbereich links:rec unten links
        g1.fillRect(135 - j / 2, 362, j + 10, 15);
        //rot bereich links :rec unten recht
        g1.fillRect(155 + j / 2, 362, j + 10, 15);
        }
        if(runde > 0 && runde < 17)
        {
        //rotbereich links,2te rec recht
        g1.fillRect(290, 266, i1 + 20, 22);
        //rotbereich links,3te rec recht
        g1.fillRect(155 + j / 2, 300, j + 10, 15);
        //rotbereich links,4te rec recht
        g1.fillRect(155 + j / 2, 325, j + 10, 15);
        }
        if(runde == 17)
        //rec4  ausser rot bereich
        g1.fillRect(145, 390, j + 10, 35);
        //rec3  ausser rot bereich
        g1.fillRect(145, 430, j + 10, 35);
        if(runde < 17)
        //1-te rec im rechten rot bereich
        g1.fillRect(530, 165, l + 10, 35);
        if(runde > 0 && runde < 17)
        {
        // kleine rec in rot bereich recht
        g1.fillRect(520, 220, l / 2 + 10, 35);
        g1.fillRect(635,220, l / 2 + 10, 35);
        // rec rechtseitig
        g1.fillRect((525 + (l + 10) / 2) - i1 / 2, 275, i1 + 10, 35);
        //rec unten
        g1.fillRect(530, 335, l + 10, 35);
        }
        g1.setColor(Color.black);
        //rec1
        g1.drawRect(145, 155, j + 10, 35);
        if(runde == 0)
        //rec2
        g1.drawRect(145, 195, j + 10, 35);
        if(runde < 17)
        {
        //kleine Rec in rot bereich links
        g1.drawRect(135 - j / 2, 240, j + 10, 15);
        g1.drawRect(155 + j / 2, 240, j + 10, 15);
        }
        if(runde > 0)
        {
        //reen Bereich links :rec unten links
        g1.drawRect(135 - j / 2, 361, j + 10, 15);
        //reen Bereich links :rec unten recht
        g1.drawRect(155 + j / 2, 361, j + 10, 15);
        }
        if(runde == 17)
        //rec4 ausser rot Bereich
        g1.drawRect(145, 390, j + 10, 35);
        if(runde > 0 && runde < 17)
        {
        //rotbereich links,2te rec recht
        g1.drawRect(290, 265, i1 + 20, 22);
        //rotbereich links,3te rec recht
        g1.drawRect(155 + j / 2, 300, j + 10, 15);
        //rotbereich links,4te rec recht
        g1.drawRect(155 + j / 2, 325, j + 10, 15);
        }
        //rec3  ausser rot bereich
        g1.drawRect(145, 430, j + 10, 35);
        if(runde < 17)
        //1-te rect rechtseitig
        g1.drawRect(530, 165, l + 10, 35);
        if(runde > 0 && runde < 17)
        {
        //klein rec in rot bereich recht
        g1.drawRect(520, 220, l / 2 + 10, 35);
        //klein rec in rot bereich recht
        g1.drawRect(635, 220, l / 2 + 10, 35);
        g1.drawRect((525 + (l + 10) / 2) - i1 / 2, 275, i1 + 10, 35);
        //rec unten in rot bereich recht
        g1.drawRect(530, 335, l + 10, 35);
        }
        g1.setColor(Color.red);
        //rot reg links
        g1.drawRect(10, 235, 500, 145);
        //rot reg recht
        g1.drawRect(515, 160, 232, 220);
        g1.setColor(Color.blue);
        if(runde == 0)
        //kleine linie
        g1.drawLine(145 + (j + 10) / 2, 195, 145 + (j + 10) / 2, 190);
        if(runde == 0)
        {
        //horizentale linie links vor rot bereich links
        g1.drawLine(145, 212, 200 - j / 2, 212);
        //vertikale linie links vor rot bereich links
        g1.drawLine(200 - j / 2, 212, 200 - j / 2, 240);
        //horizontal linie recht vor rot bereich links
        g1.drawLine(155 + j, 212, 205 + j, 212);
        //vertikale linie recht vor rot bereich links
        g1.drawLine(205 + j, 212, 205 + j, 240);
        //horizental linie neben binair
        g1.drawLine(155 + j, 108, 530 + (l + 10) / 2, 108);
        //vertikale linie recht vor rot bereich recht
        g1.drawLine(530 + (l + 10) / 2, 108, 530 + (l + 10) / 2, 165);
        }
        if(runde > 0 && runde < 17)
        {
        //linie in rot bereich links
        //vertikal klein linie recht in rot bereich links
        g1.drawLine(345 + i1 / 2, 265, 345 + i1 / 2, 256);
        //2te vertikal klein linie recht in rot bereich links
        g1.drawLine(345 + i1 / 2, 300, 345 + i1 / 2, 288);
        //3te vertikal klein linie recht in rot bereich links
        g1.drawLine(345 + i1 / 2, 340, 345 + i1 / 2, 360);
        //4te vertikal linie recht in rot bereich links
        g1.drawLine(345 + i1 / 2, 325, 345 + i1 / 2, 315);
        //horizental linie zwischen die beiden Bereiche
        g1.drawLine(345 + i1 / 2, 294, (525 + (l + 10) / 2) - i1 / 2, 294);
        //vertikal linie links in rot bereich links
        g1.drawLine(89, 255, 89, 265);
        //schraege linie
        g1.drawLine(89, 265, 280, 350);
        //horizental linie
        g1.drawLine(280, 350, 345 + i1 / 2, 350);
        //klein vertikal linie recht
        g1.drawLine(285, 255, 285, 265);
        //schraege linie
        g1.drawLine(285, 265, 90, 350);
        //kleine vertikal linie unten links
        g1.drawLine(90, 350, 90, 360);
        }
        if(runde > 0 && runde < 17)
        {
        //linie in rot bereich recht
        //vertikal linie in rot bereich recht
        g1.drawLine(530 + (l + 10) / 2, 200, 530 + (l + 10) / 2, 210);
        //horizontale linie
        g1.drawLine(520 + l / 4, 210, 635 + l / 4, 210);
        //kleine linie
        g1.drawLine(520 + l / 4, 210, 520 + l / 4, 220);
        //kleine linie
        g1.drawLine(635 + l / 4, 210, 635 + l / 4, 220);
        //vertikal kleine linie
        g1.drawLine(520 + l / 4, 255, 520 + l / 4, 265);
        //vertikal kleine linie
        g1.drawLine(635 + l / 4, 255, 635 + l / 4, 265);
        //horizontale linie
        g1.drawLine(520 + l / 4, 265, 635 + l / 4, 265);
        //kleine linie
        g1.drawLine(530 + (l + 10) / 2, 265, 530 + (l + 10) / 2, 275);
        g1.drawString("K" + runde, 518, 290);
        }
        if(runde == 17)
        {
        //vertikal linie ausserhalb der guenen bereich links
        g1.drawLine(145 - j / 4, 377, 145 - j / 4, 405);
        //vertikal linie ausserhalb der guenen bereich links
        g1.drawLine(205 + j, 377, 205 + j, 405);
        //horizentale linie ausserhalb der guenen bereich links
        g1.drawLine(145 - j / 4, 405, 145, 405);
        //horizentale linie ausserhalb der guenen bereich links
        g1.drawLine(205 + j, 405, 155 + j, 405);
        }
        g1.setColor(Color.black);
        if(btext.length() == 64)
        {
        //rec1
        g1.drawString(btext.substring(0, 32), 150, 170);
        g1.drawString(btext.substring(32, 64), 150, 185);
        }
        if(bpi.length() == 64 && runde == 0)
        {
        //rec2
        g1.drawString(bpi.substring(0, 32), 150, 210);
        g1.drawString(bpi.substring(32, 64), 150, 225);
        }
        if(li1.length() == 32 && ri1.length() == 32 && runde > 0 && runde < 17)
        {
        //32 bits jeweils
        g1.drawString(li1, 140 - j / 2, 252);
        g1.drawString(ri1, 160 + j / 2, 252);
        }
        if(runde > 0 && runde < 17 && bep.length() == 48)
        {
        //rotbereich links,2te rec recht
        g1.drawString(bep.substring(0, 24), 300, 276);
        g1.drawString(bep.substring(24, 48), 300, 286);
        }
        if(runde > 0 && runde < 17 && RTS.length() > 0)
        //rotbereich links,3te rec recht
        g1.drawString(RTS, 160 + j / 2, 312);
        if(runde > 0 && runde < 17 && PP.length() == 32)
        //4te rec recht in rot bereich links
        g1.drawString(PP, 160 + j / 2, 337);
        if(li.length() == 32 && ri.length() == 32 && runde > 0)
        {
        //rec unten links in rot bereich links
        g1.drawString(li, 140 - j / 2, 373);
        //rec unten recht in rot bereich links
        g1.drawString(ri, 160 + j / 2, 373);
        }
        if(ausgang.length() == 64 && runde == 17)
        {
        //string's unten ausserhalb der roten Bereich
        g1.drawString(ausgang.substring(0, 32), 150, 405);
        g1.drawString(ausgang.substring(32, 64), 150, 420);
        }
        if(PF.length() == 64)
        {
        g1.drawString(PF.substring(0, 32), 150, 445);
        g1.drawString(PF.substring(32, 64), 150, 460);
        }
        if(runde > 0 && runde < 17 && keys[runde - 1] != null && keys[runde - 1].length() == 56)
        {
        //1te rec in rot bereich recht
        g1.drawString(keys[runde - 1].substring(0, 28), 535, 180);
        g1.drawString(keys[runde - 1].substring(28, 56), 535, 195);
        }
        else if(runde == 0 && runde < 17 && keys[0] != null && keys[0].length() == 56)
        {
        //1te rec rot bereich recht
        g1.drawString(keys[0].substring(0, 28), 535, 180);
        g1.drawString(keys[0].substring(28, 56), 535, 195);
        }
        if(runde > 0 && runde < 17 && G.length() == 28 && D.length() == 28)
        {
        //kleine rec in rot bereich
        g1.drawString(G.substring(0, 14), 525, 235);
        g1.drawString(G.substring(14, 28), 525, 248);
        g1.drawString(D.substring(0, 14), 640, 235);
        g1.drawString(D.substring(14, 28), 640, 248);
        //rec unten in rot bereich recht
        g1.drawString(G, 535, 350);
        g1.drawString(D, 535, 365);
        }
        if(runde > 0 && runde < 17 && schlussel48.length() == 48)
        {
        int k1 = (530 + (l + 10) / 2) - i1 / 2;
        //4te rec unten in rot bereich recht
        g1.drawString(schlussel48.substring(0, 24), k1, 290);
        g1.drawString(schlussel48.substring(24, 48), k1, 305);
        }
        g1.setColor(Color.blue);
        //in binair
        g1.drawString(bschlussel.substring(0, 32), 150, 105);
        g1.drawString(bschlussel.substring(32, 64), 150, 120);
        if(runde == 0)
        {
        g1.setColor(Color.red);
        g1.drawString("Anfang", 25, 170);
        }
        if(runde > 0 && runde < 17)
        g1.drawString("Runde " + runde, 25, 170);
        if(runde == 17)
        {
        g1.setColor(Color.red);
        g1.drawString("Ende", 25, 170);
        }
        g.drawImage(bild, 0, 0, 750, 500, this);
    }
  // Ende Ereignisprozeduren

    //Eingangspermutation
    int EinP[] = {
        58, 50, 42, 34, 26, 18, 10, 2, 60, 52,
        44, 36, 28, 20, 12, 4, 62, 54, 46, 38,
        30, 22, 14, 6, 64, 56, 48, 40, 32, 24,
        16, 8, 57, 49, 41, 33, 25, 17, 9, 1,
        59, 51, 43, 35, 27, 19, 11, 3, 61, 53,
        45, 37, 29, 21, 13, 5, 63, 55, 47, 39,
        31, 23, 15, 7
    };
    //Schluesselpermutation
    int schluesselP[] = {
        57, 49, 41, 33, 25, 17, 9, 1, 58, 50,
        42, 34, 26, 18, 10, 2, 59, 51, 43, 35,
        27, 19, 11, 3, 60, 52, 44, 36, 63, 55,
        47, 39, 31, 23, 15, 7, 62, 54, 46, 38,
        30, 22, 14, 6, 61, 53, 45, 37, 29, 21,
        13, 5, 28, 20, 12, 4
    };

    //Schluesselverschiebung
    int Decal[] = {
        0, 1, 1, 2, 2, 2, 2, 2, 2, 1,
        2, 2, 2, 2, 2, 2, 1
    };
    int Decalb[] = {
        0, 0, 1, 2, 2, 2, 2, 2, 2, 1,
        2, 2, 2, 2, 2, 2, 1
    };
    //Kompressionpermutation
    int KP[] = {
        14, 17, 11, 24, 1, 5, 3, 28, 15, 6,
        21, 10, 23, 19, 12, 4, 26, 8, 16, 7,
        27, 20, 13, 2, 41, 52, 31, 37, 47, 55,
        30, 40, 51, 45, 33, 48, 44, 49, 39, 56,
        34, 53, 46, 42, 50, 36, 29, 32
    };
    //Expansionpermutation
    int EP[] = {
        32, 1, 2, 3, 4, 5, 4, 5, 6, 7,
        8, 9, 8, 9, 10, 11, 12, 13, 12, 13,
        14, 15, 16, 17, 16, 17, 18, 19, 20, 21,
        20, 21, 22, 23, 24, 25, 24, 25, 26, 27,
        28, 29, 28, 29, 30, 31, 32, 1
    };
    //P_Box-Permutation
    int PBP[] = {
        16, 7, 20, 21, 29, 12, 28, 17, 1, 15,
        23, 26, 5, 18, 31, 10, 2, 8, 24, 14,
        32, 27, 3, 9, 19, 13, 30, 6, 22, 11,
        4, 25
    };
    //Schlusspermutation
    int SchlussP[] = {
        40, 8, 48, 16, 56, 24, 64, 32, 39, 7,
        47, 15, 55, 23, 63, 31, 38, 6, 46, 14,
        54, 22, 62, 30, 37, 5, 45, 13, 53, 21,
        61, 29, 36, 4, 44, 12, 52, 20, 60, 28,
        35, 3, 43, 11, 51, 19, 59, 27, 34, 2,
        42, 10, 50, 18, 58, 26, 33, 1, 41, 9,
        49, 17, 57, 25
    };
    String Table_S[][][] = {
        {
            {
                "1110", "0100", "1101", "0001", "0010", "1111", "1011", "1000", "0011", "1010",
                "0110", "1100", "0101", "1001", "0000", "0111"
            }, {
                "0000", "1111", "0111", "0100", "1110", "0010", "1101", "0001", "1010", "0110",
                "1100", "1011", "1001", "0101", "0011", "1000"
            }, {
                "0100", "0001", "1110", "1000", "1101", "0110", "0010", "1011", "1111", "1100",
                "1001", "0111", "0011", "1010", "0101", "0000"
            }, {
                "1111", "1100", "1000", "0010", "0100", "1001", "0001", "0111", "0101", "1011",
                "0011", "1110", "1010", "0000", "0110", "1101"
            }
        }, {
            {
                "1111", "0001", "1000", "1100", "0110", "1011", "0011", "0100", "1001", "0111",
                "0010", "1101", "1100", "0000", "0101", "1010"
            }, {
                "0011", "1101", "0100", "0111", "1111", "0010", "1000", "1110", "1100", "0000",
                "0001", "1010", "0110", "1001", "1011", "0101"
            }, {
                "0000", "1110", "0111", "1011", "1010", "0100", "1101", "0001", "0101", "1000",
                "1100", "0110", "1001", "0011", "0010", "1111"
            }, {
                "1101", "1000", "1010", "0001", "0011", "1111", "0100", "0010", "1011", "0110",
                "0111", "1100", "0000", "0101", "1110", "1001"
            }
        }, {
            {
                "1010", "0000", "1001", "1110", "0110", "0011", "1111", "0101", "0001", "1101",
                "1100", "0111", "1011", "0100", "0010", "1000"
            }, {
                "1101", "0111", "0000", "1001", "0011", "0100", "0110", "1010", "0010", "1000",
                "0101", "1110", "1100", "1011", "1111", "0001"
            }, {
                "1101", "0110", "0100", "1001", "1000", "1111", "0011", "0000", "1011", "0001",
                "0010", "1100", "0101", "1010", "1110", "0111"
            }, {
                "0001", "1010", "1101", "0000", "0110", "1001", "1000", "0111", "0100", "1111",
                "1110", "0011", "1011", "0101", "0010", "1100"
            }
        }, {
            {
                "0111", "1101", "1110", "0011", "0000", "0110", "1001", "1010", "0001", "0010",
                "1000", "1001", "1011", "1100", "0100", "1111"
            }, {
                "1101", "1000", "1011", "0101", "0110", "1111", "0000", "0011", "0100", "0111",
                "0010", "1100", "0001", "1010", "1110", "1001"
            }, {
                "1010", "0110", "1001", "0000", "1100", "1011", "0111", "1101", "1111", "0001",
                "0011", "1110", "0101", "0010", "1000", "0100"
            }, {
                "0011", "1111", "0000", "0110", "1010", "0001", "1101", "1000", "1001", "0100",
                "0101", "1011", "1100", "0111", "0010", "1110"
            }
        }, {
            {
                "0010", "1100", "0100", "0001", "0111", "1010", "1011", "0110", "1000", "0101",
                "0011", "1111", "1101", "0000", "1110", "1001"
            }, {
                "1110", "1011", "0010", "1100", "0010", "0111", "1101", "0001", "0101", "0000",
                "1111", "1010", "0011", "1001", "1000", "0110"
            }, {
                "0100", "0010", "0001", "1011", "1010", "1101", "0111", "1000", "1111", "1001",
                "1100", "0101", "0110", "0011", "0000", "1110"
            }, {
                "1011", "1000", "1100", "0111", "0001", "1110", "0010", "1101", "0110", "1111",
                "0000", "1001", "1010", "0100", "0101", "1101"
            }
        }, {
            {
                "1100", "0001", "1010", "1111", "1001", "0010", "0110", "1000", "0000", "1101",
                "0011", "0100", "1110", "0111", "0101", "1011"
            }, {
                "1010", "1111", "0100", "0010", "0111", "1100", "1001", "0101", "0110", "0001",
                "1101", "1110", "0000", "1011", "0011", "1000"
            }, {
                "1001", "1110", "1111", "0101", "0010", "1000", "1100", "0011", "0111", "0000",
                "0100", "1010", "0001", "1101", "1011", "0110"
            }, {
                "0100", "0011", "0010", "1100", "1001", "0101", "1111", "1010", "1011", "1110",
                "0001", "0111", "0110", "0000", "1000", "1101"
            }
        }, {
            {
                "0100", "1011", "0010", "1110", "1111", "0000", "1000", "1101", "0011", "1100",
                "1001", "0111", "0101", "1010", "0110", "0001"
            }, {
                "1101", "0000", "1011", "0111", "0100", "1001", "0001", "1010", "1110", "0011",
                "0101", "1100", "0010", "1111", "1000", "1010"
            }, {
                "0001", "0100", "1011", "1101", "1100", "0011", "0111", "1110", "1010", "1111",
                "0110", "1000", "0000", "0101", "1001", "0010"
            }, {
                "0110", "1011", "1101", "1000", "0001", "0100", "1010", "0111", "1001", "0101",
                "0000", "1111", "1110", "0010", "0011", "1100"
            }
        }, {
            {
                "1101", "0010", "1000", "0100", "0110", "1111", "1011", "0001", "1010", "1001",
                "0011", "1110", "0101", "0000", "1100", "0111"
            }, {
                "0001", "1111", "1101", "1000", "1010", "0011", "0111", "0100", "1100", "0101",
                "0110", "1011", "0000", "1110", "1001", "0010"
            }, {
                "0111", "1011", "0100", "0001", "1001", "1100", "1110", "0010", "0000", "0110",
                "1010", "1101", "1111", "0011", "0101", "1000"
            }, {
                "0010", "0001", "1110", "0111", "0100", "1010", "1000", "1101", "1111", "1100",
                "1001", "0000", "0011", "0101", "0110", "1011"
            }
        }
    };
    String ttext;
    String btext;
    String bpi;
    String li;
    String ri;
    String li1;
    String ri1;
    String bep;
    String tverschlusseln;
    String schlussel48;
    String tkey;
    String bschlussel;
    String G;
    String D;
    String xor1;
    String RTS;
    String PP;
    String ausgang;
    String PF;
    String keys[];
    Font police_aus;
    Font police_in;
    Image bild;
    Image image;
    Thread prozess;
    int speed;
    boolean laeuft;
    boolean bverschlusseln;
    int pos;
    int runde;
    int lausgang;
    // Ende Variablen
}
